> ## Documentation Index
> Fetch the complete documentation index at: https://docs.databar.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Get table rows

> Get rows from a table with pagination and optional filtering.

**Filtering:** Use the `filter` query parameter with a JSON-encoded object. Keys are column names, values are objects with one operator.

**Operators:**
- `equals` — exact match
- `contains` — substring match (case-insensitive)
- `not_equals` — excludes exact match
- `is_empty` — column value is null (pass `true`)
- `is_not_empty` — column value is not null (pass `true`)

Multiple column filters use AND logic.

**Examples:**
- `?filter={"company":{"equals":"OpenAI"}}`
- `?filter={"name":{"contains":"Data"}}`
- `?filter={"name":{"contains":"a"},"revenue":{"equals":"5000"}}`
- `?filter={"email":{"is_not_empty":true}}`



## OpenAPI

````yaml GET /v1/table/{table_uuid}/rows
openapi: 3.1.0
info:
  title: Databar.ai API
  description: >-

    # Authentication


    Databar uses API keys to allow access to the API. You can find your API key
    in your workspace home page, but to use the REST API you’ll first need to
    schedule a call with us.

    Our API expects the API key to be included in all API requests to the server
    in the Header of your request with the key `x-apikey`.

    To find your API key, head over to your Databar workspace and click
    Integrations.


    **Example:**


    `bash

    curl https://api.databar.ai/v1/user/me -H x-apikey: {YOUR_API_KEY}`
  contact:
    email: info@databar.ai
  version: 0.1.2
servers:
  - url: https://api.databar.ai
    description: Production
security: []
paths:
  /v1/table/{table_uuid}/rows:
    get:
      tags:
        - Table
      summary: Get table rows
      description: >-
        Get rows from a table with pagination and optional filtering.


        **Filtering:** Use the `filter` query parameter with a JSON-encoded
        object. Keys are column names, values are objects with one operator.


        **Operators:**

        - `equals` — exact match

        - `contains` — substring match (case-insensitive)

        - `not_equals` — excludes exact match

        - `is_empty` — column value is null (pass `true`)

        - `is_not_empty` — column value is not null (pass `true`)


        Multiple column filters use AND logic.


        **Examples:**

        - `?filter={"company":{"equals":"OpenAI"}}`

        - `?filter={"name":{"contains":"Data"}}`

        - `?filter={"name":{"contains":"a"},"revenue":{"equals":"5000"}}`

        - `?filter={"email":{"is_not_empty":true}}`
      operationId: Get_table_rows_v1_table__table_uuid__rows_get
      parameters:
        - name: table_uuid
          in: path
          required: true
          schema:
            type: string
            format: uuid
            description: The UUID of the table to retrieve
            title: Table Uuid
          description: The UUID of the table to retrieve
        - name: per_page
          in: query
          required: false
          schema:
            type: integer
            maximum: 500
            description: Number of items per page (max 500).
            default: 100
            title: Per Page
          description: Number of items per page (max 500).
        - name: page
          in: query
          required: false
          schema:
            type: integer
            minimum: 1
            description: Page number to retrieve.
            default: 1
            title: Page
          description: Page number to retrieve.
        - name: filter
          in: query
          required: false
          schema:
            anyOf:
              - type: string
              - type: 'null'
            description: >-
              JSON-encoded filter object. Keys are column names, values are
              objects with one operator. Operators: equals, contains,
              not_equals, is_empty, is_not_empty. Example:
              {"company":{"contains":"tech"},"status":{"equals":"active"}}
            examples:
              - '{"company":{"contains":"tech"}}'
              - '{"email":{"is_not_empty":true}}'
            title: Filter
          description: >-
            JSON-encoded filter object. Keys are column names, values are
            objects with one operator. Operators: equals, contains, not_equals,
            is_empty, is_not_empty. Example:
            {"company":{"contains":"tech"},"status":{"equals":"active"}}
        - name: x-apikey
          in: header
          required: true
          schema:
            type: string
            title: API Key
            description: API Key for authentication
          description: API Key for authentication
      responses:
        '200':
          description: Table retrieved successfully
          content:
            application/json:
              schema:
                title: Response Get Table Rows V1 Table  Table Uuid  Rows Get
              example:
                has_next_page: true
                total_count: 40
                page: 1
                data:
                  - id: fec5c2e3-1f18-491b-a875-5c274f052357
                    column1: data1
                    column2: data2
        '403':
          description: Forbidden
          content:
            application/json:
              example:
                detail: Not allowed
        '404':
          description: Table not found
          content:
            application/json:
              example:
                detail: Table not found
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
components:
  schemas:
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError

````